#include <stdio.h>
#include <unistd.h>

#include <X11/Intrinsic.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdlib.h> 
#include "commands.h"

static int sock=0;
static XtInputId socket_id;
extern XtAppContext app_context;

/* pour le socket */
static char sockname[80];
int init_socket1(void) {
  struct sockaddr_un addr;
  int ret;
  sprintf (sockname, "%.60s/.xawdecode/socket", getenv ("HOME"));
  unlink(sockname);
  sock=socket(AF_UNIX,SOCK_STREAM,0);
  if(sock<0) {perror("socket");sock=0;return 0;}
  addr.sun_family=AF_UNIX;
  strcpy(addr.sun_path,sockname);
  ret=bind(sock,(struct  sockaddr*)&addr,sizeof(addr));
  if(ret<0) {perror("bind"); close(sock); sock=0;return 0;};
  ret=listen(sock,1);
  if(ret) {perror("listen"); close(sock); sock=0;return 0;}
  return 1;
}

void do_command_mult(char *c) {
  char *c2;
  do {
    c2=strchr(c,';');
    if(c2) *c2='\0';
    do_command(c);
    c=c2+1;
  } while(c2);
}

static void read_socket(XtPointer data, int *fd, XtInputId *iproc) {
  char cmd[100];
  int lus=0,nr,sock2;
  if(*fd!=sock) {fprintf(stderr,"gros probleme dans read_socket\n");return;}
  printf("execution de read_socket\n");
  sock2=accept(sock,NULL,NULL);
  if(sock2<0) {perror("accept");return;}
  do {
    nr=read(sock2,cmd+lus,100-lus);
    lus+=nr;
    if(nr<0) {perror("read");close(sock2);return;}
  } while(nr>0 && lus<100);
  if(lus==100) {fprintf(stderr,"commande trop longue");close(sock2);return;}
  cmd[lus]='\0';
  printf("commande=%s\n",cmd);
  do_command_mult(cmd);
}

void close_socket(void) {
  if(!sock) return;
  XtRemoveInput(socket_id);
  close(sock);
  if(unlink(sockname)) perror("unlink");
}

void init_socket(void) {
  if(init_socket1())
    socket_id=XtAppAddInput(app_context,sock,(XtPointer)XtInputReadMask,
			    read_socket,NULL);
  else
    fprintf(stderr,"socket deja existant ?\n");
}

